# $Revision: 1.73 $, $Date: 2010/01/02 22:07:41 $
%include	/usr/lib/rpm/macros.perl
Summary:	Smokeping - a latency grapher that uses rrdtool
Summary(pl.UTF-8):	Smokeping - narzędzie do tworzenia wykresów opóźnień sieci
Name:		smokeping
Version:	2.4.2
Release:	9
License:	GPL v2+
Group:		Networking/Utilities
Source0:	http://oss.oetiker.ch/smokeping/pub/%{name}-%{version}.tar.gz
# Source0-md5:	eb8e7679fcad35e59d7c51f2328250a2
Source1:	%{name}.init
Source2:	%{name}.conf
Source3:	%{name}-config
Source4:	%{name}-lighttpd.conf
URL:		http://oss.oetiker.ch/smokeping/
BuildRequires:	perl-tools-pod
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
Requires(post):	sed >= 4.0
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/lib/rpm/user_group.sh
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(pre):	/usr/sbin/usermod
Requires(triggerpostun):	findutils
Requires:	rc-scripts >= 0.4.1.23
Requires:	rrdtool >= 1.2
Suggests:	bind-utils
Suggests:	curl
Suggests:	echoping
Suggests:	echoping
Suggests:	fping
Suggests:	openssh-clients
Suggests:	traceroute
Provides:	group(%{name})
Provides:	user(%{name})
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoprovfiles	%{_datadir}/%{name}
%define		_noautoreq		perl(BER) perl(CGI::Session::Driver) perl(CGI::Session::Driver::DBI) perl(CGI::Session::ErrorHandler) perl(Config::Grammar) perl(Digest::HMAC) perl(Digest::HMAC_MD5) perl(JSON) perl(JSON::Converter) perl(JSON::Parser) perl(Smokeping) perl(Smokeping::ciscoRttMonMIB) perl(Smokeping::Colorspace) perl(Smokeping::Config) perl(Smokeping::Examples) perl(Smokeping::Graphs) perl(Smokeping::Master) perl(Smokeping::matchers::Avgratio) perl(Smokeping::matchers::base) perl(Smokeping::probes::base) perl(Smokeping::probes::basefork) perl(Smokeping::probes::basevars) perl(Smokeping::probes::EchoPing) perl(Smokeping::probes::EchoPingHttp) perl(Smokeping::probes::EchoPingPlugin) perl(Smokeping::probes::FPing) perl(Smokeping::probes::passwordchecker) perl(Smokeping::RRDhelpers) perl(Smokeping::RRDtools) perl(Smokeping::Slave) perl(Smokeping::sorters::base) perl(SNMP_Session) perl(SNMP_util)

# How to obtain _noautoreq:
# 1. comment out _noauto* macros
# 2. repackage smokeping
# 3. select Provides from repackage output
# 4. xclip -o | sed 's/ perl/\nperl/' > perlprov
# 5. select Requires from repackage output
# 6. xclip -o | sed 's/ perl/\nperl/' > perlreq
# 7. cat perlprov perlreq | awk '{print $1}' | sort | uniq -c | grep '^      2 ' | awk '{print $2}' | tr '\n' ' '

%define		_sysconfdir	/etc/%{name}
%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_wwwconfdir	%{_webapps}/%{_webapp}
%define		_cgi_bindir	%{_prefix}/share/%{name}

%description
SmokePing is a ICMP latency logging and graphing system. It consists
of a daemon process which organizes the latency measurements and a CGI
which presents the graphs with interesting smoke-like effects.

%description -l pl.UTF-8
Smokeping jest narzędziem do tworzenia wykresów aktywności sieci.
Używając pakietów ICMP zapisuje czas odpowiedzi poszczególnych hostów
i wyświetla je w postaci czytelnego wykresu.

%package cgi
Summary:	CGI webinterface for smokeping
Summary(pl.UTF-8):	Interfejs WWW (CGI) do smokepinga
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	webapps

%description cgi
CGI webinterface for smokeping.

%description cgi -l pl.UTF-8
Interfejs WWW (CGI) do smokepinga.

%prep
%setup -q

decruft() { grep -lr "$1" . | xargs %{__sed} -i -e "s|$1|$2|g"; }

# eliminate Tobi's quirks
decruft /usr/sepp/bin %{_bindir}

# rrdtool package goes into standard perl tree
decruft '^use lib .*rrdtool.*;' ''

decruft /usr/bin/speedy-5.8.8 %{_bindir}/speedy

sed -i -e '/\/home\/oposs\/smokeping\/software\/lib/d' htdocs/tr.cgi.dist
sed -i -e '/\/home\/oetiker\/checkouts\/smokeping\/trunk\/software\/lib/d' htdocs/smokeping.cgi.dist
sed -i -e 's|/home/oetiker/checkouts/smokeping/trunk/software/etc/config.dist|%{_sysconfdir}/config|' htdocs/smokeping.cgi.dist
# working config in wrong location
decruft "etc/config.dist" "%{_sysconfdir}/config"

sed -i -e 's#use lib qw(lib);#use lib qw(%{_datadir}/%{name});#' bin/smokeping.dist

sed -i -e 's#"cropper/#"/smokeping/cropper/#' etc/basepage.html.dist

%build
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/rc.d/init.d,%{_sysconfdir},%{_wwwconfdir},%{_sbindir}} \
	$RPM_BUILD_ROOT{%{_datadir}/%{name},%{_sharedstatedir}/%{name}/{img,rrd},%{_cgi_bindir}} \
	$RPM_BUILD_ROOT{%{_mandir}/man{1,3,5,7},/var/run/%{name}}

install etc/basepage.html.dist $RPM_BUILD_ROOT%{_sysconfdir}/basepage.html
install etc/config.dist $RPM_BUILD_ROOT%{_sysconfdir}
install etc/smokemail.dist $RPM_BUILD_ROOT%{_sysconfdir}/smokemail
install etc/smokeping_secrets.dist $RPM_BUILD_ROOT%{_sysconfdir}/smokeping_secrets
install etc/tmail.dist $RPM_BUILD_ROOT%{_sysconfdir}/tmail
install bin/smokeping.dist $RPM_BUILD_ROOT%{_sbindir}/smokeping
install bin/tSmoke.dist $RPM_BUILD_ROOT%{_sbindir}/tSmoke
cp -r htdocs/{cropper,resource,script,tr.html} $RPM_BUILD_ROOT%{_cgi_bindir}
install htdocs/smokeping.cgi.dist $RPM_BUILD_ROOT%{_cgi_bindir}/smokeping.cgi
install htdocs/tr.cgi.dist $RPM_BUILD_ROOT%{_cgi_bindir}/tr.cgi
cp -r lib/* $RPM_BUILD_ROOT%{_datadir}/%{name}
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT%{_wwwconfdir}/httpd.conf
install %{SOURCE2} $RPM_BUILD_ROOT%{_wwwconfdir}/apache.conf
install %{SOURCE4} $RPM_BUILD_ROOT%{_wwwconfdir}/lighttpd.conf
install %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/config
install doc/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
# TODO: man(3) pages from subdirectories are packaged in %_docdir too, clean them up
install doc/{,Config/,Smokeping/{,matchers/,probes/,sorters/}}*.3 $RPM_BUILD_ROOT%{_mandir}/man3
install doc/*.5 $RPM_BUILD_ROOT%{_mandir}/man5
install doc/*.7 $RPM_BUILD_ROOT%{_mandir}/man7

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 207 %{name}
%useradd -u 207 -d /var/lib/%{name} -g %{name} -s /bin/false -c "Smokeping User" %{name}
%addusertogroup smokeping adm

%post
/sbin/chkconfig --add %{name}

%preun
if [ "$1" = 0 ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = 0 ]; then
	%userremove %{name}
	%groupremove %{name}
fi

%triggerin cgi -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun cgi -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin cgi -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun cgi -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin cgi -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun cgi -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%triggerpostun -- %{name} < 2.0.5-0.3
# we put trigger on main package, because we can't trigger in new package
# this will create .rpmnew files when one installs -cgi package. but that's more than okay
if [ -f /etc/httpd/httpd.conf/99_%{name}.conf.rpmsave ]; then
	install -d %{_wwwconfdir}
	mv -f /etc/httpd/httpd.conf/99_%{name}.conf.rpmsave %{_wwwconfdir}/httpd.conf
fi

%service -q httpd reload

%banner -e %{name} << EOF
The CGI program is available as %{name}-cgi package.
EOF

%triggerpostun -- %{name} < 2.4.2-3
find /var/lib/smokeping/rrd -type f -user root -group root -name \*.rrd -mtime -7 -exec chown smokeping \{\} \;
find /var/lib/smokeping/rrd -type d -user root -group root -exec chown smokeping \{\} \;

%files
%defattr(644,root,root,755)
%doc CHANGES CONTRIBUTORS COPYRIGHT README TODO doc/*.html doc/*.txt doc/Config doc/Smokeping doc/examples
%attr(755,root,root) %{_sbindir}/smokeping
%attr(755,root,root) %{_sbindir}/tSmoke
%{_datadir}/smokeping
%exclude %{_cgi_bindir}/cropper
%exclude %{_datadir}/smokeping/smokeping.cgi
%exclude %{_cgi_bindir}/resource
%exclude %{_cgi_bindir}/script
%exclude %{_datadir}/smokeping/tr.cgi
%exclude %{_datadir}/smokeping/tr.html
%{_mandir}/man1/smokeping.1*
%{_mandir}/man1/smokeping.cgi.1*
%{_mandir}/man1/tSmoke.1*
%{_mandir}/man3/*.3*
%{_mandir}/man5/*.5*
%{_mandir}/man7/*.7*
%dir %{_sysconfdir}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/basepage.html
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config.dist
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/smokemail
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/smokeping_secrets
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/tmail
%attr(754,root,root) /etc/rc.d/init.d/smokeping
%dir %{_sharedstatedir}/%{name}
%dir %attr(775,root,smokeping) %{_sharedstatedir}/%{name}/rrd
%dir %attr(775,root,http) %{_sharedstatedir}/%{name}/img
%dir %attr(770,root,smokeping) /var/run/%{name}

%files cgi
%defattr(644,root,root,755)
%dir %attr(750,root,http) %{_wwwconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_wwwconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_wwwconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_wwwconfdir}/lighttpd.conf
%{_cgi_bindir}/cropper
%attr(755,root,root) %{_cgi_bindir}/smokeping.cgi
%{_cgi_bindir}/resource
%{_cgi_bindir}/script
%attr(755,root,root) %{_cgi_bindir}/tr.cgi
%{_cgi_bindir}/tr.html

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: smokeping.spec,v $
Revision 1.73  2010/01/02 22:07:41  pawelz
- noautoreq perl(Smokeping)
- rel 9

Revision 1.72  2009/12/18 12:51:06  pawelz
- Dropped bogus provides
- Dropped Suggests that are required via autodeps
- removed todo and build blocker
- rel 8

Revision 1.71  2009/12/03 15:56:38  glen
- should not provide perl module deps

Revision 1.70  2009/07/27 11:24:19  pawelz
- rel 7

Revision 1.69  2009/07/27 11:13:00  blues
- no, it does not require echoping. We can only suggest it.

Revision 1.68  2009/07/27 10:09:12  pawelz
- R: echoping
- rel 6

Revision 1.67  2009/07/04 13:38:45  megabajt
- release 5

Revision 1.66  2009/05/14 23:28:34  gotar
- R: rc-scripts >= 0.4.1.23 due to --pidfile daemon() option; prevents:
  nice: invalid priority `--pidfile

Revision 1.65  2009/05/12 14:33:53  blues
- we can use now separate file with TODO's

Revision 1.64  2009/02/16 11:50:11  gotar
- moved %addusertogroup from %post to %pre, added missing R(*)

Revision 1.63  2009/02/16 09:15:05  blues
- use proper macro for adding user to group, no banner

Revision 1.62  2009/02/16 01:16:14  gotar
- smokeping creates pid file on it's own, so no need for newer rc-scripts surprises

Revision 1.61  2009/02/15 23:41:46  gotar
- let's use perl-CGI-SpeedyCGI

Revision 1.60  2009/02/15 14:35:03  gotar
- added /var/run/smokeping directory for PID file (smokeping user cannot
  create directly in /var/run), R: rc-scripts supporting daemon --pidfile,
- rel. 4

Revision 1.59  2009/02/15 14:08:04  gotar
- added trigger for upgrading from smokeping < 2.4.2-3 - rrd files and dirs
  owned by root would not be accessible by daemon working as smokeping user

Revision 1.58  2009/02/15 13:36:15  gotar
- fping probe is just most common, but not required, so changed R to S and
  added %banner on how to use it

Revision 1.57  2009/01/09 12:42:43  blues
- Suggests optional perl modules

Revision 1.56  2008/11/11 13:03:34  kosmo
- run as "smokeping" user.
- do not generate config.
- do not start service during installation.

Revision 1.55  2008/11/05 18:07:53  glen
- i dislike *

Revision 1.54  2008/11/05 16:55:44  gotar
- added missing man pages, documentation config files and web resources,
- restored and updated some path fixes (do not adapter them!), added even
  more fixes... :/ altered cropper path in basepage to match httpd config,
- webserver doesn't need +x /usr/sbin/fping and CGI app doesn't check for
  it now, only smokeping daemon does (but smoketrace needs traceroute, see
  note in httpd config),
- some perl modules are required only by specific probes, added a note,
- added suggests (for probes and smoketrace),
- release 2.

Revision 1.53  2008/09/21 22:18:17  pawelz
- up to 2.4.2
- GPL version

Revision 1.52  2008/09/21 18:56:19  pawelz
- more verbose %files
- adapterized

Revision 1.51  2008/08/04 11:37:34  zbyniu
- up to 2.4.1

Revision 1.50  2008/06/25 18:16:14  qboosh
- fixed changelog encoding

Revision 1.49  2008/06/24 18:31:48  adamg
- rrdtool no longer BR-ed (thanks to Pawel Zuzelski - z (at) grabina.waw.pl)

Revision 1.48  2008/06/24 15:57:20  gotar
- removed bashizm (pointed out by Paweł Zuzelski)

Revision 1.47  2008/05/03 14:06:36  adamg
- updated to 2.3.6

Revision 1.46  2007-12-27 23:53:24  zbyniu
- up to 2.2.7

Revision 1.45  2007-06-08 10:40:59  gotar
- updated URLs

Revision 1.44  2007/02/12 22:09:15  glen
- tabs in preamble

Revision 1.43  2007/02/12 01:06:33  baggins
- converted to UTF-8

Revision 1.42  2006/09/29 21:25:58  glen
- update webapp triggers due apache1 package split

Revision 1.41  2006/09/01 10:18:47  kosmo
-  md5 updated :)

Revision 1.40  2006/09/01 10:17:11  kosmo
- updated to 2.0.9

Revision 1.39  2006/06/16 15:27:57  blues
- rel.5 - add lighttp config

Revision 1.38  2006/05/21 22:16:18  glen
- rel 4

Revision 1.37  2006/03/13 23:14:32  glen
- use %service

Revision 1.36  2006/02/03 16:47:58  baggins
- release 3

Revision 1.35  2006/02/03 16:40:54  glen
- apache-base in webapp trigger

Revision 1.34  2006/01/03 10:56:06  glen
- mark items definately need to be fixed as important

Revision 1.33  2005/12/28 16:23:20  glen
- programs moved to sbin
- img is directory, mark so in filelist
- use rpm-perlprov to generate perl deps

Revision 1.32  2005/12/28 15:07:19  blues
- rel. 2 with fixed default config (keep old way of working). STBR

Revision 1.31  2005/12/26 00:22:51  qboosh
- pl for -cgi

Revision 1.30  2005/12/25 22:29:57  glen
- use webapps
- ac-main contains incompatible version, rel 1

Revision 1.29  2005/11/30 02:03:58  zbyniu
- up to 2.0.5, cleanups

Revision 1.28  2005/10/28 21:07:27  areq
- fix

Revision 1.27  2005/10/27 09:22:25  blues
- smokeping libs are not in perl dirs

Revision 1.26  2005/10/26 13:56:02  blues
- started 2.0.x series - this is needed for current rrdtool

Revision 1.24  2005/10/26 12:34:17  gotar
- upgraded to 1.43

Revision 1.23  2005/09/04 16:56:35  megabajt
- BR: sed >= 4.0

Revision 1.22  2005/07/17 21:32:17  gotar
- upgraded to 1.42

Revision 1.21  2005/05/30 17:32:41  gotar
- upgraded to 1.41, STBR

Revision 1.20  2005/05/13 19:26:24  zbyniu
- up to 1.40, proper perl name

Revision 1.19  2005/05/04 19:45:50  darekr
- proper License

Revision 1.18  2005/02/01 21:27:37  paszczus
- updated to 1.38

Revision 1.17  2005/01/15 11:18:49  darekr
- updated to 1.37

Revision 1.16  2005/01/07 11:26:38  adamg
- updated to 1.36
- BuildRequires: rrdtool

Revision 1.15  2004/12/17 17:47:22  darekr
- updated to 1.34

Revision 1.14  2004/12/01 01:27:35  zbyniu
- added PreReq: rc-scripts and Requires(): /sbin/chkconfig for daemon

Revision 1.13  2004/10/31 16:25:46  paladine
- spaces->tabs
- formatting

Revision 1.12  2004/10/16 10:01:17  gotar
- fixed summaries, BR: perl-tools-pod,
- fixed paths: httpd config directory, FHS compliance (use datadir
  instead of libdir for perl modules, sharedstatedir instead of httpd
  home for logs and images, proper permission for images directory),
- fixed hardcoded paths (http://www.greenkey.net/~curtis/rpm/src/),
- chmod +x cgi, chmod o-x initscript,
- fixed init script and apache config file; do not mess in the main,
- added working default config,
- run %post only for install, not for upgrade,
- PLD-style installs, cosmetics,
- release 1, STBR.

Revision 1.11  2004/08/23 12:42:40  pawelb
- up to 1.31

Revision 1.10  2004/07/21 22:09:56  pawelb
- created post scripts
- TODO: make proper paths in configfile
- not tested

Revision 1.9  2004/07/21 19:21:41  qboosh
- cleanups, missing dirs

Revision 1.8  2004/07/20 23:17:57  domelu
- cosmetics (url)
- spaces -> tabs

Revision 1.7  2004/07/20 22:50:35  domelu
- proper group

Revision 1.6  2004/07/20 22:46:09  pawelb
- NFY
- do not hit me :)

Revision 1.5  2004/07/20 22:15:00  ankry
- restored changelog

Revision 1.4  2004/07/20 22:12:51  ankry
- adapterized, R/BR: perl-base, other cosmetics

Revision 1.3  2004/07/20 22:06:53  pawelb
- cosmetic #2 :/

Revision 1.2  2004/07/20 21:57:18  pawelb
- cosmetic

Revision 1.1  2004/07/20 21:38:24  pawelb
- init
- NFY
